#pragma once
#include <iostream>
//using namespace std;

//------------------------------------------------------------------------------

enum Day {
	sunday, monday, tuesday, wednesday, thursday, friday, saturday
};

class Date {
public:
	enum Month {
		jan = 1, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec
	};

	class Invalid { };                 // to throw as exception

	Date(int y, Month m, int d);       // check for valid date and initialize
	Date();                            // default constructor
	// the default copy operations are fine

	// non-modifying operations:
	int   day()   const { return d; }
	Month month() const { return m; }
	int   year()  const { return y; }

	// modifying operations:
	void add_day();
	void add_day(int n);
	void add_month();
	void add_month(int n);
	void add_year(int n);

private:
	int   y;
	Month m;
	int   d;
};  //end Date

//Helper functions
//------------------------------------------------------------------------------

bool is_date(int y, Date::Month m, int d); // true for valid date

//------------------------------------------------------------------------------

bool leapyear(int y);                  // true if y is a leap year

//------------------------------------------------------------------------------

bool operator==(const Date& a, const Date& b);
bool operator!=(const Date& a, const Date& b);

//------------------------------------------------------------------------------

std::ostream& operator<<(std::ostream& os, const Date& d);
std::istream& operator>>(std::istream& is, Date& dd);

//Date next_Sunday(Date);
//Day  day_of_week(Date);